package com.unipi.talepis;

import java.util.ArrayList;
import java.util.List;

public class Car {
    private List<SpeedListener> speedListenerList = new ArrayList<>();
    private int maxSpeed;
    private int minSpeed;
    private int currentSpeed;

    public Car(int maxSpeed, int minSpeed, int currentSpeed) {
        this.maxSpeed = maxSpeed;
        this.minSpeed = minSpeed;
        this.currentSpeed = currentSpeed;
    }
    public void speedUp(int increment){
        currentSpeed+=increment;
        if (currentSpeed>maxSpeed)
            processSpeedEvent(new SpeedEvent(maxSpeed,minSpeed,currentSpeed));
    }
    public void slowDown(int decrement){
        currentSpeed-=decrement;
        if (currentSpeed<minSpeed)
            processSpeedEvent(new SpeedEvent(maxSpeed,minSpeed,currentSpeed));
    }
    public synchronized void addSpeedListener(SpeedListener listener){
        if (!speedListenerList.contains(listener))
            speedListenerList.add(listener);
    }
    private void processSpeedEvent(SpeedEvent event){
        List<SpeedListener> temp;
        synchronized (this){
            if (speedListenerList.size()==0)
                return;
            temp = new ArrayList<>(speedListenerList);
        }
        for (SpeedListener listener:temp) {
            listener.speedExceeded(event);
            listener.speedGoneBelow(event);
        }
    }
}
